# Calibrations

There are two types of calibration files here:
1. rX_cal: The internal calibrations of the arms (done in factory and read from arms - does not need updating).
2. rX_tforms: The transformations of the arms relative to the print bed (may require updating).

## Recalibrating Arms
This is to calibrate the arms - i.e. find their position/transform relative to the print bed.

1. Remove previous readings - delete the entire measurements section from the yaml file
2. Connect to the arm you are calibrating with the various `roslaunch` commands
3. Run Calibrator with the file for the robot you want to update.

```bash
python Calibrator ../calibrations/rX_tforms.yaml
```

4. Use Keyboard controls to take the arm to the 5 positions. The 5 positions are labelled below. The points are relative to each robot.

```
+---------------+---------------+---------------+
|               |               |               |
|               |               |               |
|               |               |               |
|               |               |               |
|               |               |               |
+---------------+---------------+---------------+
|               |               |               |
|               |               |               |
5               |       1       |               2
|               |               |               |
|               |               |               |
+---------------+---------------+---------------+
|               |               |               |
|               |               |               |
|               |               |               |
|               |               |               |
|               |               |               |
4---------------+---------------+---------------3
                    ROBOT HERE
```
